----------------------------------------------------------------------------------------------------------------
--[[ 	GupPetet by Gup 																						]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_OnLoad				 																		]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_OnLoad(self)

	SLASH_GUPPET1 = "/GupPet" 
	
	if (GetLocale() ~= "esES") then
		SLASH_GUPPET2 = "/GP" ;
	end
	
 	SlashCmdList["GUPPET"] = GupPet_SlashCommand;
	
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("COMPANION_LEARNED");	
	self:RegisterEvent("COMPANION_UPDATE");
	
	self:RegisterEvent("LEARNED_SPELL_IN_TAB");
	self:RegisterEvent("UPDATE_BINDINGS");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	
	self:RegisterEvent("CHAT_MSG_ADDON");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
	
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_OnEvent				 																		]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_OnEvent(self, event, ...) 

	if event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		
		--Update the companion Data  
		GupPet_DataHandler_UpdateCompanion() ;
		
		--Place the MinimapButton + AddonInterface
		GupPet_InterfaceMinimapButton_Update();
		GupPet_Interface_MakeButtons();
		
		--Update Player data
		GupPet_User_UpdateSpellBookData(); -- Get all class information
		
		--Send my version to the guild
		GupPet_SendMyVersion( "GUILD" );  -- This seems to be bugged 
		
		--Activate some extra 
		GupPet_Mount_UpdateAutoDismount(); -- Enables / Disables the function
		
		-- Update the ingamebutton things
		GupPet_IngameButtons_Update();
		GupPet_IngameButtons_UpdateDrag(); -- Sets the Drag buttons
		
		-- Companion
		GupPet_Companion_AutoBoot();

		
	elseif event == "ADDON_LOADED" then
		local addonName = ... ;
		
		if addonName == "GupPet" then
			GupPet_DataHandler_Loaded();
		end
	
	elseif event == "COMPANION_LEARNED" then

		GupPet_DataHandler_UpdateCompanion() ;
		
		--Interface updated
		GupPet_InterfaceCompanion_Tabs_Update();
		GupPet_InterfaceCompanion_MainFrame_Update(); 
	
	elseif event == "COMPANION_UPDATE" then	
		
		local type = ... ;
	
		if type == nil then 
			self:UnregisterEvent("COMPANION_UPDATE");
			
			-- If true then data is Good so cache is filled ! 
			if GupPet_DataHandler_UpdateCompanion( true ) then
				
				
				--Interface updated
				GupPet_InterfaceCompanion_Tabs_Update();
				GupPet_InterfaceCompanion_MainFrame_Update(); 
			else
			self:RegisterEvent("COMPANION_UPDATE");
			end
		end
	
	elseif event == "LEARNED_SPELL_IN_TAB" then 
		
		--Update Player data
		GupPet_User_UpdateSpellBookData();
	
	elseif event == "UI_ERROR_MESSAGE" then
		
		local errorMsg = ... ;
		GupPet_Mount_AutoDismount(errorMsg);
		
	elseif 	event == "UPDATE_BINDINGS" or event == "PLAYER_REGEN_ENABLED" then
		
		if InCombatLockdown() then
			self:RegisterEvent("PLAYER_REGEN_ENABLED") ;
		else
			self:UnregisterEvent("PLAYER_REGEN_ENABLED") ;
					
			GupPet_IngameButtons_UpdateBindings();
		end	
		
	elseif event == "PLAYER_REGEN_DISABLED" then

		GupPet_User_BuildCombatMacro();
		
	elseif event == "CHAT_MSG_ADDON" then	
		
		local prefix , message , distributionType , sender = ... ;
		
		GupPet_RecieveChat( prefix , message , distributionType , sender );
	
	elseif event == "RAID_ROSTER_UPDATE" then
		
		if not self.lastUpdate then self.lastUpdate = 0 end;
		
		--Do not send YourVersion more then every 5 min
		if self.lastUpdate + 300 < GetTime() then
			self.lastUpdate = GetTime();
			
	--		GupPet_SendMyVersion( "PARTY" );	
	--		GupPet_SendMyVersion( "RAID" );
	--		GupPet_SendMyVersion( "BATTLEGROUND" );
		end
	end	
	
end


----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_SlashCommand			 																		]]--
----------------------------------------------------------------------------------------------------------------
function GupPet_SlashCommand(msg)
	
	msg = string.lower( msg ) ;
	
	if msg == GUPPET_L["SLASH_S_AQM"] or msg == GUPPET_L["SLASH_T_AQM"]   then GupPet_Mount_Aquatic();
	elseif msg == GUPPET_L["SLASH_S_MM"] or msg == GUPPET_L["SLASH_T_MM"] then GupPet_Mount_Multi();
	elseif msg == GUPPET_L["SLASH_S_GM"] or msg == GUPPET_L["SLASH_T_GM"] then GupPet_Mount_Ground();
	elseif msg == GUPPET_L["SLASH_S_FM"] or msg == GUPPET_L["SLASH_T_FM"] then GupPet_Mount_Fly();
	elseif msg == GUPPET_L["SLASH_S_AM"] or msg == GUPPET_L["SLASH_T_AM"] then GupPet_Mount_Auto();
	elseif msg == GUPPET_L["SLASH_S_CC"] or msg == GUPPET_L["SLASH_T_CC"] then GupPet_Companion_Pre();
	elseif msg == GUPPET_L["SLASH_S_OM"] or msg == GUPPET_L["SLASH_T_OM"] then ShowUIPanel(GupPetet_InterfaceOptionsFrame);
	else
		GupPet_Text( GUPPET_L["UNKNOWNSLASHCOMMAND"] );
	end

end

----------------------------------------------------------------------------------------------------------------
--[[	GupPetet_SendMyVersion				 																]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_SendMyVersion( target )	-- WHISPER ,  PARTY", "RAID", "GUILD", "BATTLEGROUND

	local sendVersion = 0 ;

	if GupPet_SavedOptions["Version"]["Current"] < GupPet_SavedOptions["Version"]["Found"] then
		sendVersion = GupPet_SavedOptions["Version"]["Found"] ; 
	else
		sendVersion = GupPet_SavedOptions["Version"]["Current"] ;
	end
	
	if( target == "GUILD" and IsInGuild()  )or
	  ( target == "PARTY" and UnitInParty("player") )or
	  ( target == "RAID" and UnitInRaid("player") )or
	  ( target == "BATTLEGROUND" and UnitInBattleground("player") )then
	
		SendAddonMessage("GupPetVersion", sendVersion , target ) ;
	end
	
	
	
	
	--[[
	elseif To == "WHISPER" and Target then
		SendAddonMessage( "GupPetet_RVer" , MyVersion , "WHISPER" , Target ) ;

	end 
	]]
	
end


function GupPet_RecieveChat( prefix , message , distributionType , sender )

	if prefix == "GupPetVersion" then
		
		n_message = tonumber(message);
		
		if n_message > GupPet_SavedOptions["Version"]["Current"] and n_message > GupPet_SavedOptions["Version"]["Found"]   then	 
			GupPet_Text( "|cffee4400".. GUPPET_L["NEWVERSIONFOUND"] .. n_message ) ;
			GupPet_SavedOptions["Version"]["Found"] = n_message ;
		end
		
	end


	--[[   
				
		if arg1 == "GupPetetVersion" then -- Listen for new versions

		elseif 	arg1 == "GupPetet_GVer" then -- GupPetet_GetVersion
			GupPetet_SendMyVersion( "WHISPER" , arg4 ) ;
		elseif 	arg1 == "GupPetet_RVer" then -- GupPetet_ReturnVersion
			GupPetet_Text( arg4 .. " uses ".. arg2);
		end
		]]

end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_Text						 																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Text( text )
	
	DEFAULT_CHAT_FRAME:AddMessage( "GupPet: ".. text ) ;
end

