local GupPet_CompanionCache = {} ; -- Almost the same as the Mount cache but is verry tempy

--------------------------------------------------------------------------------------------------------------
-- GupPet_Companion_CreateCache																				--
--------------------------------------------------------------------------------------------------------------
function GupPet_Companion_CreateCache(locationID)
	
	--Create the list 
	local nrCompanions = #GupPet_SavedData["Companion"]["Critter"] ;
	local nrOffSnowballs = GetItemCount( 17202 ); -- Snowball -> Itemid 17202 ;
	local oneInTheListIsSummoned = false ;
	local oneInTheListNeedsSnowBall = false ;
	
	GupPet_CompanionCache = {} ;
		
	for i=1 , nrCompanions do
		--For nr Weight trow it in
				
		if GupPet_SavedData["Companion"][ "Critter" ][ i ]["Weight"][ locationID ] and GupPet_SavedData["Companion"][ "Critter" ][ i ]["Weight"][ locationID ] > 0 then
			_, _, _, _, IsSummoned = GetCompanionInfo("CRITTER", GupPet_SavedData["Companion"][ "Critter" ][i]["Slot"] );
			
			if IsSummoned then 
				oneInTheListIsSummoned = true ;
			elseif GupPet_SavedData["Companion"][ "Critter" ][ i ]["Special"] == "Snowball" and nrOffSnowballs == 0 then
				oneInTheListNeedsSnowBall = true ;
			else
				for y=1 , GupPet_SavedData["Companion"][ "Critter" ][ i ]["Weight"][ locationID ] do
					tinsert( GupPet_CompanionCache , GupPet_SavedData["Companion"][ "Critter" ][ i ]["Slot"]  );
				end
			end
		end
	end
	
	-- For producing lovley error messages
	if #GupPet_CompanionCache == 0 then
		if oneInTheListNeedsSnowBall then
			tinsert( GupPet_CompanionCache , -2 ) ;
		elseif oneInTheListIsSummoned == true then
			tinsert( GupPet_CompanionCache , -1 ) ;
		end
	end
end

--------------------------------------------------------------------------------------------------------------
-- GupPet_Companion_Pre																						--
--------------------------------------------------------------------------------------------------------------
function GupPet_Companion_Pre()
	--First get the ID
	local zoneID , globalWorldID , citiesID , instanceID , arenaID , battleGroundID = GupPet_DataHandler_getLocationID()
	local summonFromZoneID = 0 ;
	
	if zoneID > 0 then
		GupPet_Companion_CreateCache( zoneID );
		
		if #GupPet_CompanionCache > 0 then
			summonFromZoneID = zoneID ;
		end
	end
	
	if summonFromZoneID == 0 then
	
		_, instanceType = IsInInstance() ;
		local checkZoneID = 0 ;
	
		if ( IsResting() ) then
			checkZoneID = citiesID ;
		elseif ( instanceType == "pvp" ) then
			checkZoneID = battleGroundID ;
		elseif ( instanceType == "arena" ) then
			checkZoneID = arenaID ;
		elseif ( instanceType == "party" or instanceType == "raid" ) then
			checkZoneID = instanceID ;
		else
			checkZoneID = globalWorldID ;
		end
		
		GupPet_Companion_CreateCache( checkZoneID);
		if #GupPet_CompanionCache > 0 then
			summonFromZoneID = checkZoneID ;
		end
	end
		
	if summonFromZoneID == 0 then
		GupPet_Companion_CreateCache( globalWorldID);
		if #GupPet_CompanionCache > 0 then
			summonFromZoneID = globalWorldID ;
		else
			tinsert( GupPet_CompanionCache , -3 ) ;
		end
	end
	
	-- Go Summon
	if summonFromZoneID > 0 then
		GupPet_Companion_Summon( summonFromZoneID  )
		return true;
	end
	return false;
end

--------------------------------------------------------------------------------------------------------------
-- GupPet_Companion_Summon																					--
--------------------------------------------------------------------------------------------------------------
function GupPet_Companion_Summon( locationID )
	
	-- Make the errors
	if GupPet_CompanionCache[1] == -1 then
		GupPet_Text( GUPPET_L["CANTCALLCRITTERNONEINTHETABLE"] ) ;
		return;
	elseif GupPet_CompanionCache[1] == -2 then
		GupPet_Text( GUPPET_L["CANTCALLCRITTERNOSNOWBALL"] ) ;
		return;
	elseif GupPet_CompanionCache[1] == -3 then
		GupPet_Text( GUPPET_L["CANTCALLCRITTER"] ) ;
		return;
	end
	
	--Summon 
	local randomSummon = math.random( #GupPet_CompanionCache  );
	CallCompanion("CRITTER", GupPet_CompanionCache[randomSummon] ) ;
	
	-- Save the new pet ID 
	GupPet_SavedOptions["AutoCritter"]["PetOfTheDay"]["PetID"] = GetCompanionInfo("CRITTER", GupPet_CompanionCache[randomSummon] ) ; 

end


 
-- TEMP VARS
GupPet_Companion_Auto = {} ;
 
----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoBoot		 															--	
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoBoot()

	GupPet_Companion_Auto.Frame = CreateFrame("Frame", "GupPet_Companion_AutoFrameq"); 
	GupPet_Companion_Auto.TotalElapsed = 0;
	GupPet_Companion_Auto.Frame:Hide() ;
	GupPet_Companion_Auto.Force = false ; 

	GupPet_Companion_Auto.Frame:SetScript("OnEvent", function(self, event, ...) GupPet_Companion_AutoEvent(event, ...); end ) ;
	GupPet_Companion_Auto.Frame:SetScript("OnUpdate", function(self, elap) GupPet_Companion_AutoUpdate(self, elap); end ) ;
	GupPet_Companion_Auto.Frame:SetScript("OnShow", function() GupPet_Companion_Auto.TotalElapsed = 0; end) ;
	
	-- ResumonFrame
	GupPet_Companion_Auto.ResummonFrame = CreateFrame("Frame", "GupPet_Companion_AutoResummonFrame"); 
	GupPet_Companion_Auto.ResummonFrame.TotalElapsed = 0;
	GupPet_Companion_Auto.ResummonFrame:Hide() ;
	GupPet_Companion_Auto.ResummonFrame:SetScript("OnUpdate", GupPet_Companion_AutoResummonUpdate  ) ;
	GupPet_Companion_Auto.ResummonFrame:SetScript("OnShow", function() GupPet_Companion_Auto.ResummonFrame.TotalElapsed = 0; end) ;	
	
	GupPet_Companion_AutoSetEnable() ;
	GupPet_Companion_AutoResumonSetEnable();
end

----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoPetOfTheDay			 										--					
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoPetOfTheDay()

	if GupPet_SavedOptions.AutoCritter.PetOfTheDay.Enabled then
	
		local _, currentMonth, currentDay, currentYear = CalendarGetDate();
	
		if GupPet_SavedOptions.AutoCritter.PetOfTheDay.Month == currentMonth 
			and GupPet_SavedOptions.AutoCritter.PetOfTheDay.Day == currentDay 
				and GupPet_SavedOptions.AutoCritter.PetOfTheDay.Year == currentYear then 

			-- Summon saved pet 
			for i = 1 , GUPPET_SAVEDDATA[ "Companion" ]["Total"] do 
			
				if GupPet_SavedOptions.AutoCritter.PetOfTheDay.PetId ==  GUPPET_SAVEDDATA[ "Companion" ][i]["CreatureID"] then
				
					CallCompanion("CRITTER", GUPPET_SAVEDDATA[ "Companion" ][i]["Slot"] ) ;
				
					break ;
				end
			
			end
		
		
			return true ;
		else 
			-- Get a new pet random
			GupPet_SavedOptions.AutoCritter.PetOfTheDay.Month = currentMonth ;
			GupPet_SavedOptions.AutoCritter.PetOfTheDay.Day = currentDay ;
			GupPet_SavedOptions.AutoCritter.PetOfTheDay.Year = currentYear;
		
			return false; 
		end
	else
		-- Its of go random
	
		return false; 
	end
end



-----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoResumonSetEnable	 														--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoResumonSetEnable()

	if GupPet_SavedOptions.AutoCritter.Resummon.Enabled then
		GupPet_Companion_Auto.ResummonFrame:Show() ;
	else
		GupPet_Companion_Auto.ResummonFrame:Hide() ;
		GupPet_Companion_Auto.Force = false ;
	end
end

----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoResumonUpdate		 							--							
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoResummonUpdate(self, elap)

	GupPet_Companion_Auto.ResummonFrame.TotalElapsed = GupPet_Companion_Auto.ResummonFrame.TotalElapsed + elap ;

	if GupPet_Companion_Auto.ResummonFrame.TotalElapsed > GupPet_SavedOptions.AutoCritter.Resummon.Delay then
		
		if IsResting() or not( GupPet_SavedOptions.AutoCritter.Resummon.CityOnly) then
			GupPet_Companion_Auto.Force = true ;
			GupPet_Companion_Auto.Frame:Show();
			
		else
			GupPet_Companion_Auto.Force = false ;
		end
		
		GupPet_Companion_Auto.ResummonFrame.TotalElapsed = 0 ;
	end
end

----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoUpdate		 																--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoUpdate(self, elap)

	GupPet_Companion_Auto.TotalElapsed = GupPet_Companion_Auto.TotalElapsed + elap ;
	
	if GupPet_Companion_Auto.TotalElapsed > GupPet_SavedOptions.AutoCritter.Delay then 
		
		GupPet_Companion_Auto.TotalElapsed = 0 ;
		_, instanceType = IsInInstance() ;
		
		if GupPet_SavedOptions.AutoCritter.City and IsResting() then
		elseif ( GupPet_SavedOptions.AutoCritter.BattleGround and instanceType == "pvp" ) then
		elseif ( GupPet_SavedOptions.AutoCritter.Arena and instanceType == "arena" ) then
		elseif ( GupPet_SavedOptions.AutoCritter.Party and instanceType == "party" ) then
		elseif ( GupPet_SavedOptions.AutoCritter.Raid and instanceType == "raid" ) then
		elseif ( GupPet_SavedOptions.AutoCritter.Outside and not( IsResting() ) and instanceType == "none"  ) then
		else
			GupPet_Companion_Auto.Frame:Hide() ;
			return ;
		end
		
		if IsMounted() or IsFlying() or UnitInVehicle("player") then
		
			if GupPet_SavedOptions.AutoCritter.DismissMounted then
				DismissCompanion('CRITTER') ;
			end
				
			GupPet_Companion_Auto.Frame:Hide() ;
			return 
		 
		elseif IsStealthed() or IsFalling() or UnitCastingInfo("player") or UnitChannelInfo("player") or InCombatLockdown() or not(HasFullControl()) 
			or UnitBuff("player", GupPet_TempUserData["FeignDeath"]["Name"]) 
			or UnitBuff("player", GupPet_TempUserData["SpiritOfRedemption"]["Name"] ) 
			or UnitBuff("player", GupPet_TempUserData["Invisibility"]["Name"])
			or UnitIsDead("player") 
			or UnitIsDeadOrGhost("player")
			or UnitBuff("player", TUTORIAL_TITLE11  ) or UnitBuff("player", TUTORIAL_TITLE12 ) then
				
			return 
		end
		
		-- Dont summmon while looting
		if LootFrame:IsVisible() then
			return
		end
		
		if GupPet_Companion_Auto.Force then
			GupPet_Companion_Auto.Force = false ;
		else
		
			for i=1,GetNumCompanions("CRITTER") do 

				_, _, _, _, IsSummoned = GetCompanionInfo("CRITTER", i);
			
				if IsSummoned then 
			
					GupPet_Companion_Auto.Frame:Hide() ;
					return ;
				end 
			end	
		end
		
		if GupPet_Companion_OnQuest() then
			GupPet_Companion_Auto.Frame:Hide() ;
			return ;
		end
		
		if not GupPet_Companion_AutoPetOfTheDay() then 
			GupPet_Companion_Pre() ;
		end
		
		GupPet_Companion_Auto.Frame:Hide() ;		
	end
end

-----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoHold							 														--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoHold()
	GupPet_Companion_Auto.TotalElapsed = -2 ;
end


----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoSetEnable	 																--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoSetEnable()

	if GupPet_SavedOptions.AutoCritter.Enabled then
	
		GupPet_Companion_Auto.Frame:RegisterEvent("COMPANION_UPDATE") ;		--For dismounting
		GupPet_Companion_Auto.Frame:RegisterEvent("PLAYER_UNGHOST") ; 		--Walking to corpse
		GupPet_Companion_Auto.Frame:RegisterEvent("PLAYER_ALIVE") ;			--Res
		GupPet_Companion_Auto.Frame:RegisterEvent("ZONE_CHANGED") ;			--Portal or summon not far away 
		GupPet_Companion_Auto.Frame:RegisterEvent("ZONE_CHANGED_NEW_AREA") ;	--Portal 
		GupPet_Companion_Auto.Frame:RegisterEvent("PLAYER_CONTROL_GAINED") ; --After taxi
		GupPet_Companion_Auto.Frame:RegisterEvent("UNIT_EXITED_VEHICLE") ; 	--After using a vehicle
		GupPet_Companion_Auto.Frame:RegisterEvent("UPDATE_STEALTH") ; 		--Dismiss for Stealth
		
		GupPet_Companion_Auto.Frame:Show() ;
	else
		GupPet_Companion_Auto.Frame:UnregisterEvent("COMPANION_UPDATE") ;
		GupPet_Companion_Auto.Frame:UnregisterEvent("PLAYER_UNGHOST") ;	
		GupPet_Companion_Auto.Frame:UnregisterEvent("PLAYER_ALIVE") ;		
		GupPet_Companion_Auto.Frame:UnregisterEvent("ZONE_CHANGED_NEW_AREA") ;
		GupPet_Companion_Auto.Frame:UnregisterEvent("ZONE_CHANGED") ;
		GupPet_Companion_Auto.Frame:UnregisterEvent("PLAYER_CONTROL_GAINED") ;
		GupPet_Companion_Auto.Frame:UnregisterEvent("UNIT_EXITED_VEHICLE") ;
		GupPet_Companion_Auto.Frame:UnregisterEvent("UPDATE_STEALTH") ;
	end
end

----------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_AutoEvent		 																--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_Companion_AutoEvent(event, ... )

	if ... and ... == "CRITTER" then
		return ;
	end
	
	if IsStealthed() then
		
		DismissCompanion('CRITTER') ;
		return ;
	end
	
	if InCombatLockdown() then 
				
		GupPet_Companion_Auto.Frame:RegisterEvent("PLAYER_REGEN_ENABLED") ;
		return  ;
	else
		GupPet_Companion_Auto.Frame:UnregisterEvent("PLAYER_REGEN_ENABLED") ;
	end
				
	if not( HasFullControl() ) then 
		return ;
	end
		
	GupPet_Companion_Auto.Frame:Show() ;
end

 
--------------------------------------------------------------------------------------------------------------
--	GupPet_Companion_OnQuest	 																				--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Companion_OnQuest()
	local CurrentMap = ""
 
	for Item , Map in pairs(GupPet_ItemData.Quest) do
	
		if GetItemCount(Item) > 0 then
			 
			if #Map == 0 then
				return true
			else
				if not WorldMapFrame:IsVisible()  then
					SetMapToCurrentZone();
					CurrentMap = GetMapInfo() ;
				else
					return true
				end
			end

			for i = 1 , #Map do

				if Map[i] == CurrentMap then
					return true
				end
			end
			
		end
	end
 
 return false ;
end 
 	