

--------------------------------------------------------------------------------------------------------------
-- GupPet_IngameButtons_Update																				--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_Update()

	if GupPet_SavedOptions["IngameButton"]["Show"] then
		GupPet_IngameButtonFrame:Show() ;
		RegisterStateDriver( GupPet_IngameButtonFrame , "visibility", "[vehicleui] hide; show") ;
	else
		GupPet_IngameButtonFrame:Hide() ;
		RegisterStateDriver( GupPet_IngameButtonFrame , "visibility", "hide") ;
		return
	end

	--GupPet_IngameButtonFrame:SetClampedToScreen( true ) ; 
	GupPet_IngameButtonFrame:SetPoint( GupPet_SavedOptions["IngameButton"]["RelativePoint"] , GupPet_SavedOptions["IngameButton"]["xOffset"] , GupPet_SavedOptions["IngameButton"]["yOffset"] );
	GupPet_IngameButtonFrame:SetScale( GupPet_SavedOptions["IngameButton"]["Scale"] );

	
	-----
	local buttons = {} ;
	
	GupPet_IngameButtonFrameAuto:Hide();
	GupPet_IngameButtonFrameAquatic:Hide();
	GupPet_IngameButtonFrameGround:Hide();
	GupPet_IngameButtonFrameFly:Hide();
	GupPet_IngameButtonFrameMulti:Hide();
	GupPet_IngameButtonFrameCritter:Hide();
	
	
	if GupPet_SavedOptions["IngameButton"]["MountButton"] == "Auto" and 
		( #GupPet_SavedData["Companion"]["FlyMount"] > 0 or #GupPet_SavedData["Companion"]["GroundMount"] > 0 or #GupPet_SavedData["Companion"]["AquaticMount"] > 0 or GupPet_TempUserData["classGroundUsable"] or GupPet_TempUserData["classFlyUsable"] or GupPet_TempUserData["classAquaticUsable"] ) then
		-- AutoButton
		tinsert(buttons , "GupPet_IngameButtonFrameAuto") ;
		
		
	else
		-- Check all buttons
		if #GupPet_SavedData["Companion"]["AquaticMount"] > 0 or GupPet_TempUserData["classAquaticUsable"] then
			tinsert(buttons , "GupPet_IngameButtonFrameAquatic") ;
		end
		
		if #GupPet_SavedData["Companion"]["GroundMount"] > 0 or GupPet_TempUserData["classGroundUsable"] then
			tinsert(buttons , "GupPet_IngameButtonFrameGround") ;
		end
	
		if #GupPet_SavedData["Companion"]["FlyMount"] > 0 or GupPet_TempUserData["classFlyUsable"] then
			tinsert(buttons , "GupPet_IngameButtonFrameFly") ;
		end
		
--		if #GupPet_SavedData["Companion"]["MultiMount"] > 0 then
--			tinsert(buttons , "GupPet_IngameButtonFrameMulti") ;
--		end
		
	end
	
	if #GupPet_SavedData["Companion"]["Critter"] > 0 and GupPet_SavedOptions.IngameButton.CritterButton then
		tinsert(buttons , "GupPet_IngameButtonFrameCritter") ;
	end
	
	---------------------------
	
	GupPet_IngameButtonFrame:SetHeight(32);
	
	if #buttons == 1 then
		_G[ buttons[1] ]:SetPoint("CENTER",0,0);
		GupPet_IngameButtonFrame:SetWidth(32);
	
	elseif #buttons == 2 then
		_G[ buttons[1] ]:SetPoint("CENTER",-17.5,0);
		_G[ buttons[2] ]:SetPoint("CENTER",17.5,0);
		GupPet_IngameButtonFrame:SetWidth(67);
	
	elseif #buttons == 3 then
		_G[ buttons[1] ]:SetPoint("CENTER",-35,0);
		_G[ buttons[2] ]:SetPoint("CENTER",0,0);
		_G[ buttons[3] ]:SetPoint("CENTER",35,0);
		GupPet_IngameButtonFrame:SetWidth(102);
	
	elseif #buttons == 4 then
		_G[ buttons[1] ]:SetPoint("CENTER",-52.5,0);
		_G[ buttons[2] ]:SetPoint("CENTER",-17.5,0);
		_G[ buttons[3] ]:SetPoint("CENTER", 17.5,0);
		_G[ buttons[4] ]:SetPoint("CENTER", 52.5,0);
		GupPet_IngameButtonFrame:SetWidth(138);
	
	elseif #buttons == 5 then
		_G[ buttons[1] ]:SetPoint("CENTER",-70,0);
		_G[ buttons[2] ]:SetPoint("CENTER",-35,0);
		_G[ buttons[3] ]:SetPoint("CENTER",0,0);
		_G[ buttons[4] ]:SetPoint("CENTER",35,0);
		_G[ buttons[5] ]:SetPoint("CENTER",70,0);
		GupPet_IngameButtonFrame:SetWidth(169);
	else
		GupPet_IngameButtonFrame:Hide() ;
		return;
	end
	
	for i=1 , #buttons do
		_G[ buttons[i] ]:Show();
	end
		
		
	-- Change them to vertical
	if GupPet_SavedOptions.IngameButton.Alignment == "Vertical" then
		for i=1 , #buttons do
		
		local _, _, _, xOfs, yOfs = _G[ buttons[i] ]:GetPoint() ;
		_G[ buttons[i] ]:SetPoint("CENTER",yOfs,-xOfs);
				
		end
		
		GupPet_IngameButtonFrame:SetHeight( GupPet_IngameButtonFrame:GetWidth() );
		GupPet_IngameButtonFrame:SetWidth(32);
		
	end
	
	GupPet_IngameButtons_UpdateIcons();
	GupPet_IngameButtons_UpdateAllTooltips();

end

--------------------------------------------------------------------------------------------------------------
--	GupPet_IngameButtons_BuildAutoMacro																		--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_BuildAutoMacro( self )

	-- To avoid errors
	if InCombatLockdown() then return end 

	if #GupPet_SavedData["Companion"]["MultiMount"] > 0 then
		self:SetAttribute("ctrl-macrotext1"		, "/run GupPet_Mount_Multi()" );
	end
		
	-------------------------------------------------
	-- MAGE
	-------------------------------------------------
	if GupPet_TempUserData.UnitClass == "MAGE" then
		if  GupPet_TempUserData["Blink"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Blink"]["Name"] );
		end
		

		if GupPet_SavedOptions["Class"]["SlowFallOnFalling"] and GupPet_TempUserData["SlowFall"]["Usable"]  and IsFalling() and not (IsMounted() or UnitInVehicle("player")) then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["SlowFall"]["Name"] ) ;
			return 
		end
		
		if #GupPet_SavedData["Companion"]["GroundMount"] == 0 and  GupPet_TempUserData["Blink"]["Usable"] then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Blink"]["Name"] ) ;
			return
		end
		
		
	-------------------------------------------------
	-- HUNTER
	-------------------------------------------------
	elseif GupPet_TempUserData.UnitClass == "HUNTER" then
		-- Place the hunter crap under alt
		if GupPet_TempUserData["Pack"]["Usable"] and GetNumPartyMembers() > 0 then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Pack"]["Name"] );
		elseif GupPet_TempUserData["Cheetah"]["Usable"]  then	
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Cheetah"]["Name"] );
		end
		
		-- if you dont have anny mounts
		if #GupPet_SavedData["Companion"]["GroundMount"] == 0 then
			
			if GupPet_TempUserData["Pack"]["Usable"] and GetNumPartyMembers() > 0 then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Pack"]["Name"]);
			elseif GupPet_TempUserData["Cheetah"]["Usable"]  then	
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Cheetah"]["Name"]);
			end
			
			return
		end
	
	-------------------------------------------------
	-- DRUID
	-------------------------------------------------	
	elseif GupPet_TempUserData.UnitClass == "DRUID" then
		self:SetAttribute("ctrl-macrotext1"		, "/cancelform\n/script GupPetet_AutoMultiGround()" );
		-- 
		if GupPet_TempUserData["Travel"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/cancelform\n/use "..GupPet_TempUserData["Travel"]["Name"] );
		end
		
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			self:SetAttribute("shift-macrotext1"  , "");
			return
		end
	
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 and not GupPet_SavedOptions.Class.Inconsistent  then
			self:SetAttribute("macrotext"		, "/cancelform");
			self:SetAttribute("shift-macrotext1", "/cancelform");
			self:SetAttribute("alt-macrotext1"	, "/cancelform");
			return
		end
		
		-- if you dont have any groundmounts
		if GUPPET_SAVEDDATA.Ground.Total == 0 then
			if IsSwimming() and GupPet_TempUserData["Aquatic"]["Usable"] and GupPet_SavedOptions["Class"]["AquaticForm"] then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
			elseif GupPet_TempUserData["Travel"]["Usable"] then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Travel"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Travel"]["Name"] )
			end
			return
		end
		
		if GetUnitSpeed("player") > 0 and GupPet_TempUserData["Travel"]["Usable"] and GupPet_SavedOptions["Class"]["TravelOnFormWalking"] then
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Travel"]["Name"] )
			else
				self:SetAttribute("shift-macrotext1", "/cancelform\n/script GupPetet_AutoGround()" )
				
			end
		
		
			if GupPetet_CanFly() and IsOutdoors() then 
				
				if (GupPet_SavedOptions["Class"]["FlyForm"] or IsFalling() ) and GupPet_TempUserData["FastFly"]["Usable"] then
			
					self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["FastFly"]["Name"] )

				elseif (GupPet_SavedOptions["Class"]["FlyForm"] or IsFalling() ) and GupPet_TempUserData["SlowFly"]["Usable"] then
				
					self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["SlowFly"]["Name"] )
				else
					self:SetAttribute("macrotext"		, "/cancelform\n/script GupPetet_AutoMounten()" )
				end
				return
			
			elseif IsSwimming() and GupPet_TempUserData["Aquatic"]["Usable"] and GupPet_SavedOptions["Class"]["AquaticForm"] then
				
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
			 
			elseif GetUnitSpeed("player") > 0 and GupPet_TempUserData["Travel"]["Usable"] and GupPet_SavedOptions["Class"]["TravelOnFormWalking"] and IsOutdoors() then
				
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Travel"]["Name"] )
			 
			elseif GupPet_TempUserData["Cat"]["Usable"] and GupPet_SavedOptions["Class"]["CatOnIndoors"] and IsIndoors() then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Cat"]["Name"] )
				
			else
				
				self:SetAttribute("macrotext"		, "/cancelform\n/script GupPetet_AutoGround()" )
			 
			end
 
 
			return
		
	-------------------------------------------------
	-- SHAMAN
	-------------------------------------------------
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
		if GupPet_TempUserData["Ghost"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Ghost"]["Name"] );
		end
		
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			self:SetAttribute("shift-macrotext1"  , "");
			return
		end
		
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 then
			self:SetAttribute("macrotext"		, "/cancelform");
			self:SetAttribute("shift-macrotext1", "/cancelform");
			self:SetAttribute("alt-macrotext1"	, "/cancelform");
			return
		end
		
		-- If you are swimming cast the WaterWalking
		if GupPet_TempUserData["WaterWalking"]["Usable"] and  IsSwimming() then
			self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["WaterWalking"]["Name"] ) ;
		end
		
		if GupPet_TempUserData["WaterWalking"]["Usable"] and  IsSwimming()  and  GupPet_SavedOptions["Class"]["UseWaterWalking"]  then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["WaterWalking"]["Name"] ) ;
			return
		end
		
		-- Put Ghostwolf on the button if you are moving etc
		if GupPet_TempUserData["Ghost"]["Usable"] and  GetUnitSpeed("player") > 0  and  GupPet_SavedOptions["Class"]["GhostWolfOnWalking"]  then

			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Ghost"]["Name"] )
			return
		end
		
		-- if you dont have any groundmounts
		if GUPPET_SAVEDDATA.Ground.Total == 0 and GupPet_TempUserData["Ghost"]["Usable"] then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Ghost"]["Name"] )
			self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Ghost"]["Name"] )
			return
		end
	
	-------------------------------------------------
	-- DEATHKNIGHT
	-------------------------------------------------
	elseif GupPet_TempUserData.UnitClass == "DEATHKNIGHT" then
		if GupPet_TempUserData["PathOfFrost"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["PathOfFrost"]["Name"] ) ;
		end
		
		-- If you are swimming cast the PathOfFrost
		if GupPet_TempUserData["PathOfFrost"]["Usable"] and  IsSwimming()  and  GupPet_SavedOptions["Class"]["UsePathOfFrost"]  then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["PathOfFrost"]["Name"] ) ;
			return
		end
		
	-------------------------------------------------
	-- WORGEN
	-------------------------------------------------
	elseif GupPet_TempUserData.UnitClass == "WORGEN" then
	else
		--	If your not a druid / mage / hunter / shaman kill calling of this function
		self:SetScript("PreClick", function (self, button, down)  end) ; 
	end
	
	
	self:SetAttribute("macrotext"		, "/run GupPet_Mount_Auto();" );
	self:SetAttribute("shift-macrotext1", "/script GupPet_Mount_Ground()" )


end

function GupPet_IngameButtons_BuildAquaticMacro( self )
	-- To avoid errors
	if InCombatLockdown() then return end 
	
	
	if GupPet_TempUserData.UnitClass == "DRUID" then
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext", "");
			return
		end
		
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 and not GupPet_SavedOptions.Class.Inconsistent  then
			self:SetAttribute("macrotext"		, "/cancelform");
			return
		end
		
		if IsSwimming() and GupPet_TempUserData["Aquatic"]["Usable"] and GupPet_SavedOptions["Class"]["AquaticForm"] then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
			return
		end
		
	end
	
	self:SetAttribute("macrotext"		, "/run GupPet_Mount_Aquatic();" );
	
end	

function GupPet_IngameButtons_BuildMultiMacro( self )
	-- To avoid errors
	if InCombatLockdown() then return end 
	
	if GupPet_TempUserData.UnitClass == "DRUID" then
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			return
		end
		
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 and not GupPet_SavedOptions.Class.Inconsistent  then
			self:SetAttribute("macrotext"	, "/cancelform");
			return
		end
		self:SetAttribute("macrotext"		, "/cancelform\n/run GupPet_Mount_Multi()" );
		
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			return
		end
		
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 and not GupPet_SavedOptions.Class.Inconsistent  then
			self:SetAttribute("macrotext"		, "/cancelform");
			return
		end
		
		self:SetAttribute("macrotext"		, "/cancelform\n/run GupPet_Mount_Multi()" );
		
	else
		self:SetScript("PreClick", function (self, button, down)  end) ; 
		self:SetAttribute("macrotext"		, "/run GupPet_Mount_Multi()" );
	end
	
end

function GupPet_IngameButtons_BuildGroundMacro( self )
	-- To avoid errors
	if InCombatLockdown() then return end 
	
	if #GupPet_SavedData["Companion"]["MultiMount"] > 0 then
		self:SetAttribute("ctrl-macrotext1"		, "/run GupPet_Mount_Multi()" );
	end
	
	-------------------------------------------------
	-- MAGE
	-------------------------------------------------
	if GupPet_TempUserData.UnitClass == "MAGE" then
		if  GupPet_TempUserData["Blink"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Blink"]["Name"] );
		end
		
		if GupPet_SavedOptions["Class"]["SlowFallOnFalling"] and GupPet_TempUserData["SlowFall"]["Usable"]  and IsFalling() and not (IsMounted() or UnitInVehicle("player")) then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["SlowFall"]["Name"] ) ;
			return 
		end
		
		if #GupPet_SavedData["Companion"]["GroundMount"] == 0 and  GupPet_TempUserData["Blink"]["Usable"] then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Blink"]["Name"] ) ;
			return
		end
		
	-------------------------------------------------
	-- HUNTER
	-------------------------------------------------
	elseif GupPet_TempUserData.UnitClass == "HUNTER" then
		-- Place the hunter crap under alt
		if GupPet_TempUserData["Pack"]["Usable"] and GetNumPartyMembers() > 0 then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Pack"]["Name"] );
		elseif GupPet_TempUserData["Cheetah"]["Usable"]  then	
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Cheetah"]["Name"] );
		end
		
		-- if you dont have anny mounts
		if #GupPet_SavedData["Companion"]["GroundMount"] == 0 then
			
			if GupPet_TempUserData["Pack"]["Usable"] and GetNumPartyMembers() > 0 then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Pack"]["Name"]);
			elseif GupPet_TempUserData["Cheetah"]["Usable"]  then	
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Cheetah"]["Name"]);
			end
			
			return
		end
	
	
	
	elseif GupPet_TempUserData.UnitClass == "DRUID" then
		self:SetAttribute("ctrl-macrotext1"		, "/cancelform\n/script GupPetet_AutoMultiGround()" );
		-- 
		if GupPet_TempUserData["Travel"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/cancelform\n/use "..GupPet_TempUserData["Travel"]["Name"] );
		end
		
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			self:SetAttribute("shift-macrotext1"  , "");
			return
		end
	
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 and not GupPet_SavedOptions.Class.Inconsistent  then
			self:SetAttribute("macrotext"		, "/cancelform");
			self:SetAttribute("shift-macrotext1", "/cancelform");
			self:SetAttribute("alt-macrotext1"	, "/cancelform");
			return
		end
		
		-- if you dont have any groundmounts
		if GUPPET_SAVEDDATA.Ground.Total == 0 then
			if GupPet_TempUserData["Travel"]["Usable"] then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Travel"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Travel"]["Name"] )
			end
			return
		end
		
		
		if IsSwimming() and GupPet_TempUserData["Aquatic"]["Usable"] and GupPet_SavedOptions["Class"]["AquaticForm"] then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Aquatic"]["Name"] )
				
			elseif GetUnitSpeed("player") > 0 and GupPet_TempUserData["Travel"]["Usable"] and GupPet_SavedOptions["Class"]["TravelOnFormWalking"] and IsOutdoors()  then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Travel"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Travel"]["Name"] )
				
			elseif GupPet_TempUserData["Cat"]["Usable"] and GupPet_SavedOptions["Class"]["CatOnIndoors"] and IsIndoors() then
				self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Cat"]["Name"] )
				self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Cat"]["Name"] )
				
			else
				self:SetAttribute("macrotext"		, "/cancelform\n/script GupPetet_AutoGround()" )
				self:SetAttribute("shift-macrotext1", "/cancelform\n/script GupPetet_AutoGround()" )
			end
					
			return
		
		
		
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
		if GupPet_TempUserData["Ghost"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["Ghost"]["Name"] );
		end
		
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			self:SetAttribute("shift-macrotext1"  , "");
			return
		end
		
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 then
			self:SetAttribute("macrotext"		, "/cancelform");
			self:SetAttribute("shift-macrotext1", "/cancelform");
			self:SetAttribute("alt-macrotext1"	, "/cancelform");
			return
		end
		
		-- If you are swimming cast the WaterWalking
		if GupPet_TempUserData["WaterWalking"]["Usable"] and  IsSwimming()  and  GupPet_SavedOptions["Class"]["UseWaterWalking"]  then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["WaterWalking"]["Name"] ) ;
			self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["WaterWalking"]["Name"] ) ;
			return
		end
		
		-- Put Ghostwolf on the button if you are moving etc
		if GupPet_TempUserData["Ghost"]["Usable"] and  GetUnitSpeed("player") > 0  and  GupPet_SavedOptions["Class"]["GhostWolfOnWalking"]  then

			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Ghost"]["Name"] )
			self:SetAttribute("shift-macrotext1", "/script GupPetet_AutoGround()" )
			return
		end
		
		-- if you dont have any groundmounts
		if GUPPET_SAVEDDATA.Ground.Total == 0 and GupPet_TempUserData["Ghost"]["Usable"] then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["Ghost"]["Name"] )
			self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["Ghost"]["Name"] )
			return
		end
		
		
	elseif GupPet_TempUserData.UnitClass == "DEATHKNIGHT" then
		if GupPet_TempUserData["PathOfFrost"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/use "..GupPet_TempUserData["PathOfFrost"]["Name"] ) ;
		end
		
		-- If you are swimming cast the PathOfFrost
		if GupPet_TempUserData["PathOfFrost"]["Usable"] and  IsSwimming()  and  GupPet_SavedOptions["Class"]["UsePathOfFrost"]  then
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["PathOfFrost"]["Name"] ) ;
			return
		end
		
	elseif GupPet_TempUserData.UnitClass == "WORGEN" then
	else
		--	If your not a druid / mage / hunter / shaman kill calling of this function
		self:SetScript("PreClick", function (self, button, down)  end) ; 
	end
	
	self:SetAttribute("macrotext"		, "/script GupPetet_AutoGround()" )
	self:SetAttribute("shift-macrotext1", "/script GupPetet_AutoGround()" )

end


function GupPet_IngameButtons_BuildFlyMacro( self )
	-- To avoid errors
	if InCombatLockdown() then return end 
	
	if #GupPet_SavedData["Companion"]["MultiMount"] > 0 then
		self:SetAttribute("ctrl-macrotext1"		, "/run GupPet_Mount_Multi()" );
	end
	
	--Check for the Classes
	if GupPet_TempUserData.UnitClass == "MAGE" then
	elseif GupPet_TempUserData.UnitClass == "HUNTER" then
	elseif GupPet_TempUserData.UnitClass == "DRUID" then
	
		self:SetAttribute("ctrl-macrotext1"		, "/cancelform\n/script GupPetet_AutoMultiGround()" );
		-- 
		if GupPet_TempUserData["Travel"]["Usable"] then
			self:SetAttribute("alt-macrotext1", "/cancelform\n/use "..GupPet_TempUserData["Travel"]["Name"] );
		end
		
		-- If mounted or inVehicle .. Leave and kill the rest of the event 
		if GupPetet_Exit()  then
			self:SetAttribute("macrotext"		  , "");
			self:SetAttribute("shift-macrotext1"  , "");
			return
		end
	
		-- If you are in a form kill the form only.
		if GetShapeshiftForm() > 0 and not GupPet_SavedOptions.Class.Inconsistent  then
			self:SetAttribute("macrotext"		, "/cancelform");
			self:SetAttribute("shift-macrotext1", "/cancelform");
			self:SetAttribute("alt-macrotext1"	, "/cancelform");
			return
		end
	
		if (GupPet_SavedOptions["Class"]["FlyForm"] or IsFalling() ) and GupPet_TempUserData["FastFly"]["Usable"] then
			
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["FastFly"]["Name"] );
			self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["FastFly"]["Name"] );
			self:SetAttribute("alt-macrotext1"	, "/use "..GupPet_TempUserData["FastFly"]["Name"] );
			
		elseif (GupPet_SavedOptions["Class"]["FlyForm"] or IsFalling() ) and GupPet_TempUserData["SlowFly"]["Usable"] then
		
			self:SetAttribute("macrotext"		, "/use "..GupPet_TempUserData["SlowFly"]["Name"] );
			self:SetAttribute("shift-macrotext1", "/use "..GupPet_TempUserData["SlowFly"]["Name"] );
			self:SetAttribute("alt-macrotext1"	, "/use "..GupPet_TempUserData["SlowFly"]["Name"] );
		else
			self:SetAttribute("macrotext"		, "/cancelform\n/script GupPetet_AutoFly()" );
			self:SetAttribute("shift-macrotext1", "/cancelform\n/script GupPetet_AutoFly()" );
			self:SetAttribute("alt-macrotext1"	, "/cancelform\n/script GupPetet_AutoFly()" );
		end
		return 
	
	
	elseif GupPet_TempUserData.UnitClass == "SHAMAN" then
	
	
	
	
--	elseif GupPet_TempUserData.UnitClass == "DEATHKNIGHT" then
--	elseif GupPet_TempUserData.UnitClass == "WORGEN" then
	else
		self:SetScript("PreClick", function (self, button, down)  end) ; --	If your not a druid / mage / hunter / shaman kill calling of this function
	end

	self:SetAttribute("macrotext"		, "/script GupPetet_AutoFly()" )
	self:SetAttribute("shift-macrotext1", "/script GupPetet_AutoFly()" )
	self:SetAttribute("alt-macrotext1"	, "/script GupPetet_AutoFly()" )
		
end


----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_UpdateTooltip																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_UpdateAllTooltips()

	GupPet_IngameButtons_UpdateTooltipAquatic();
	GupPet_IngameButtons_UpdateTooltipGround();
	GupPet_IngameButtons_UpdateTooltipFly();
	GupPet_IngameButtons_UpdateTooltipAuto();
	
	GupPet_IngameButtons_UpdateTooltipCritter();
	
end


function GupPet_IngameButtons_UpdateTooltipGround()
	if not GupPet_SavedOptions["IngameButton"]["HideTooltip"] then
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameGround"] , GUPPET_L["INGAMEBUTTONS_GROUNDTOOLTIP"] ,GUPPET_L["INGAMEBUTTONS_GROUNDTOOLTIPR"] );
	else
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameGround"] , "","" );
	end
end

function GupPet_IngameButtons_UpdateTooltipFly()
	if not GupPet_SavedOptions["IngameButton"]["HideTooltip"] then
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameFly"] , GUPPET_L["INGAMEBUTTONS_FLYTOOLTIP"] ,GUPPET_L["INGAMEBUTTONS_FLYTOOLTIPR"] );
	else
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameFly"] , "","" );
	end
end

function GupPet_IngameButtons_UpdateTooltipAquatic()
	if not GupPet_SavedOptions["IngameButton"]["HideTooltip"] then
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameAquatic"] , GUPPET_L["INGAMEBUTTONS_AQUATICTOOLTIP"] ,GUPPET_L["INGAMEBUTTONS_AQUATICTOOLTIPR"] );
	else
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameAquatic"] , "","" );
	end
end

function GupPet_IngameButtons_UpdateTooltipAuto()
	if not GupPet_SavedOptions["IngameButton"]["HideTooltip"] then
		-- if DRUID / SHAMAN 
		--[[
			GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR_DRUID"] = " +Alt to use TravelFrom";
			GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR_SHAMAN"] = " +Alt to use GhostWolf";
		]]
		-- end
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameAuto"] , GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIP"] ,GUPPET_L["INGAMEBUTTONS_AUTOTOOLTIPR"] );
	else
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameAuto"] , "","" );
	end
end

function GupPet_IngameButtons_UpdateTooltipCritter()
	if not GupPet_SavedOptions["IngameButton"]["HideTooltip"] then
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameCritter"] , GUPPET_L["INGAMEBUTTONS_CRITTERTOOLTIP"] ,GUPPET_L["INGAMEBUTTONS_CRITTERTOOLTIPR"] );
	else
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameCritter"] , "","" );
	end
end


function GupPet_IngameButtons_UpdateTooltipMove()
	if not GupPet_SavedOptions["IngameButton"]["HideTooltip"] then
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveTopLeft"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIP"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIPR"] );
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveTopRight"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIP"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIPR"] );
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveBottomLeft"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIP"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIPR"] );
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveBottomRight"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIP"] , GUPPET_L["INGAMEBUTTONS_MOVETOOLTIPR"] );
	else
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveTopLeft"] ,"", "" );
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveTopRight"] , "", "" );
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveBottomLeft"] , "", "" );
		GupPet_IngameButtons_UpdateTooltip( _G["GupPet_IngameButtonFrameMoveBottomRight"] , "", "" );
	end
end

function GupPet_IngameButtons_UpdateTooltip( button , text , textRequirement )

	button.tooltipText = text ; 
	button.tooltipRequirement = textRequirement ;

end



----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_Drag																				]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_UpdateDrag()
	
	GupPet_IngameButtons_Drag( not(GupPet_SavedOptions["IngameButton"]["Lock"]) )
	

end


function GupPet_IngameButtons_Drag( show )

	GupPet_SavedOptions["IngameButton"]["Lock"] = not show ;

	if show then
		_G["GupPet_IngameButtonFrame".."MoveTopLeft" ]:Show();
		_G["GupPet_IngameButtonFrame".."MoveTopRight"  ]:Show();
		_G["GupPet_IngameButtonFrame".."MoveBottomLeft"  ]:Show();
		_G["GupPet_IngameButtonFrame".."MoveBottomRight"  ]:Show();
	else
		_G["GupPet_IngameButtonFrame".."MoveTopLeft"  ]:Hide();
		_G["GupPet_IngameButtonFrame".."MoveTopRight"  ]:Hide();
		_G["GupPet_IngameButtonFrame".."MoveBottomLeft"  ]:Hide();
		_G["GupPet_IngameButtonFrame".."MoveBottomRight"  ]:Hide();
	end
end


----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_DragStart																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_DragStart()

	GupPet_IngameButtonFrame:SetMovable( true ) ;
	GupPet_IngameButtonFrame:StartMoving();

end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_DragStop																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_DragStop()

	GupPet_IngameButtonFrame:StopMovingOrSizing() ;
	GupPet_IngameButtonFrame:SetMovable( false ) ;
	
	_, _, GupPet_SavedOptions.IngameButton.RelativePoint, GupPet_SavedOptions.IngameButton.xOffset, GupPet_SavedOptions.IngameButton.yOffset = GupPet_IngameButtonFrame:GetPoint()
		
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_DragReset																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_DragReset()

	GupPet_IngameButtonFrame:ClearAllPoints(); 
	GupPet_IngameButtonFrame:SetPoint("CENTER",0, 0);   
	_, _, GupPet_SavedOptions["IngameButton"]["RelativePoint"], GupPet_SavedOptions["IngameButton"]["xOffset"], GupPet_SavedOptions["IngameButton"]["yOffset"] = GupPet_IngameButtonFrame:GetPoint()
	
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_UpdateHotkeys																	]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_UpdateHotkeys(self , actie )
	
	local hotkey = _G[self:GetName().."HotKey"];
    local key = GetBindingKey( actie );

	local text = GetBindingText(key, "KEY_", 1);
    if  text == "" or GupPet_SavedOptions["IngameButton"]["HideKeyBind"]  then
       hotkey:Hide();
    else
		hotkey:SetText(text);
		hotkey:SetPoint("TOPLEFT", self, "TOPLEFT", -2, -2);
		hotkey:Show();
    end
end


----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_UpdateIcons																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_UpdateIcons()

 	_G["GupPet_IngameButtonFrameAutoIcon"]:SetTexture( GupPet_SavedOptions.IngameButton.Icons.Auto );
	
	_G["GupPet_IngameButtonFrameAquaticIcon"]:SetTexture( GupPet_SavedOptions.IngameButton.Icons.Aquatic ) ;
	_G["GupPet_IngameButtonFrameGroundIcon"]:SetTexture( GupPet_SavedOptions.IngameButton.Icons.Ground ) ;
	_G["GupPet_IngameButtonFrameMultiIcon"]:SetTexture( GupPet_SavedOptions.IngameButton.Icons.Multi ) ;
	_G["GupPet_IngameButtonFrameFlyIcon"]:SetTexture( GupPet_SavedOptions.IngameButton.Icons.Fly) ;
	
	_G["GupPet_IngameButtonFrameCritterIcon"]:SetTexture( GupPet_SavedOptions.IngameButton.Icons.Critter) ;
	
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_UpdateBindings	 																]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_UpdateBindings()

	GupPet_IngameButtons_UpdateBinding( "GUPPET_AUTOMOUNT" 		, GupPet_IngameButtonFrameAuto  );
	GupPet_IngameButtons_UpdateBinding( "GUPPET_AQUATICMOUNT"	, GupPet_IngameButtonFrameAquatic );
	GupPet_IngameButtons_UpdateBinding( "GUPPET_GROUNDMOUNT" 	, GupPet_IngameButtonFrameGround );
	GupPet_IngameButtons_UpdateBinding( "GUPPET_FLYMOUNT" 		, GupPet_IngameButtonFrameFly );
	GupPet_IngameButtons_UpdateBinding( "GUPPET_MULTIMOUNT" 	, GupPet_IngameButtonFrameMulti );
	GupPet_IngameButtons_UpdateBinding( "GUPPET_CRITTER" 		, GupPet_IngameButtonFrameCritter );
	
	GupPet_IngameButtons_UpdateHotkeys( GupPet_IngameButtonFrameAuto	, "GUPPET_AUTOMOUNT" );
	GupPet_IngameButtons_UpdateHotkeys( GupPet_IngameButtonFrameAquatic	, "GUPPET_AQUATICMOUNT" );
	GupPet_IngameButtons_UpdateHotkeys( GupPet_IngameButtonFrameGround	, "GUPPET_GROUNDMOUNT" );
	GupPet_IngameButtons_UpdateHotkeys( GupPet_IngameButtonFrameFly		, "GUPPET_FLYMOUNT" );
	GupPet_IngameButtons_UpdateHotkeys( GupPet_IngameButtonFrameMulti	, "GUPPET_MULTIMOUNT" );
	GupPet_IngameButtons_UpdateHotkeys( GupPet_IngameButtonFrameCritter	, "GUPPET_CRITTER" );
end

----------------------------------------------------------------------------------------------------------------
--[[	GupPet_IngameButtons_UpdateBinding	 																]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPet_IngameButtons_UpdateBinding( binding , button )

	ClearOverrideBindings(button) ;
	local key1, key2 = GetBindingKey(binding) ;
	if key1 then
		SetOverrideBindingClick( button, true, key1, button:GetName() ) ;
	end 
	if key2 then
		SetOverrideBindingClick( button, true, key2, button:GetName() ) ;
	end 
end 

