GupPet_MountCache = {} ;


--------------------------------------------------------------------------------------------------------------
--	GupPet_Mount_SetAutoDismount						 														--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_SetAutoDismount( active ) 
	if active then
		GupPet:RegisterEvent("UI_ERROR_MESSAGE");
		GupPet_SavedOptions["AutoDismount"] = true ;
	else
		GupPet:UnregisterEvent("UI_ERROR_MESSAGE")
		GupPet_SavedOptions["AutoDismount"] = false ;
	end
end

function GupPet_Mount_UpdateAutoDismount() 
	GupPet_Mount_SetAutoDismount( GupPet_SavedOptions["AutoDismount"] ) ;
end

function GupPet_Mount_AutoDismount( msg )

	if UnitOnTaxi("player") then 
	elseif ( msg == ERR_NOT_WHILE_MOUNTED 
		or msg == SPELL_FAILED_NOT_MOUNTED 
		or msg == ERR_ATTACK_MOUNTED 
		or msg == ERR_TAXIPLAYERALREADYMOUNTED 
		or msg == SPELL_FAILED_NOT_ON_MOUNTED ) 
		and not IsFlying() then
		
		Dismount() ;
	end
		
	return ;
end


--------------------------------------------------------------------------------------------------------------
--	GupPetet_Mount_CanFlyThisContinent		 																--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_CanFlyThisContinent()

	local currentZoneName = GetZoneText();			-- Get current zone
	
	--Flight Master's License
--	if not GupPet_TempUserData["CanFlyContinentVanilla"] then
--		local zoneNamesVanilla = { GetMapZones(1) } ;
--		GupPet_Mount_LoadZones( zoneNamesVanilla , GetMapZones(2) );
--		
--		for i = 1 , #zoneNamesVanilla do
--			if currentZoneName ==  zoneNamesVanilla[i] then
--				return false ;
--			end
--		end
--	end
	
	-- ColdWeather 
	if not GupPet_TempUserData["CanFlyContinentNorthrend"] then
		local zoneNamesNorthrend = { GetMapZones(4) } ;	-- Get all zones in northerend
		
		for i = 1 , #zoneNamesNorthrend do
			if currentZoneName ==  zoneNamesNorthrend[i] then
				return false ;
			end
		end
	end
	
	return true;
  
end

local function GupPet_Mount_LoadZones(c, ...)
	for i=1,select('#', ...),1 do
		tinsert(c, select(i,...) );
	end
end


function GupPet_Mount_ForceFly() 
	
	--First get the ID
	local zoneID , globalWorldID , citiesID , instanceID , arenaID , battleGroundID = GupPet_DataHandler_getLocationID()
	
	if zoneID > 0 then
		return GupPet_DataHandler_Location_GetUserFlyAsGroundID(zoneID);
	end
	
	_, instanceType = IsInInstance() ;
	local checkZoneID = 0 ;

	if ( IsResting() ) then
		return GupPet_DataHandler_Location_GetUserFlyAsGroundID(citiesID);
	elseif ( instanceType == "pvp" ) then
		return GupPet_DataHandler_Location_GetUserFlyAsGroundID(battleGroundID);
	elseif ( instanceType == "arena" ) then
		return GupPet_DataHandler_Location_GetUserFlyAsGroundID(arenaID);
	elseif ( instanceType == "party" or instanceType == "raid" ) then
		return GupPet_DataHandler_Location_GetUserFlyAsGroundID(instanceID);
	else
		return GupPet_DataHandler_Location_GetUserFlyAsGroundID(globalWorldID);
	end
	

end

--------------------------------------------------------------------------------------------------------------
--	GupPetet_CanSwim								 															--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_CanSwim()
	if IsSwimming()  then
		return true ;
	end
	return false;
end

--------------------------------------------------------------------------------------------------------------
--	GupPetet_CanGround							 															--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_CanGround()

	if GupPet_SavedData["Companion"]["GroundMount"][1] then
		return IsUsableSpell( GupPet_SavedData["Companion"]["GroundMount"][1]["SpellID"] )
	end
	return false ;

end

--------------------------------------------------------------------------------------------------------------
--	GupPetet_CanFly							 																--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_CanFly()

	-- Flyable Area
	if  not(IsFlyableArea()) then
		return false ;
	end

	-- Swimming logic
	local isFlyerUsable = false ;
	if GupPet_SavedData["Companion"]["FlyMount"][1] then
		isFlyerUsable = IsUsableSpell( GupPet_SavedData["Companion"]["FlyMount"][1]["SpellID"] )
	end
	if IsSwimming() and not( isFlyerUsable ) then
		return false ;
	end
	
	-- Check for active World PVP
	local numWorldPvP = GetNumWorldPVPAreas();
	local currentZone = GetZoneText() ;
	
	for i=1,numWorldPvP do
		local	_, localizedName, isActive = GetWorldPVPAreaInfo(i);
		
		if localizedName == currentZone and isActive then
			return false ;
		end
	end
	
	
	-- Dont have the ColdWeather or Flight Master's License
	if GupPet_Mount_CanFlyThisContinent()  then
		return true ;
	else
		return false ;
	end
end

--------------------------------------------------------------------------------------------------------------
--	GupPet_Exit								 																--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Exit()

	if IsMounted() then
	
		Dismount() ;
		return true ;
	
	elseif UnitInVehicle("player")  then
	
		VehicleExit() ;
		return true ;
	else
		return false ;
	end
end



--------------------------------------------------------------------------------------------------------------
--	GupPet_Mount_CreateCache					 																--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_CreateCache( locationID , companionType )

--	GupPet_MountCache[zoneName][companionType]
	if not GupPet_MountCache[locationID] then
		GupPet_MountCache[locationID] = {} ;
	end
	
	if not GupPet_MountCache[locationID][companionType] then
		GupPet_MountCache[locationID][companionType] = {} ;
	
		--Create the list 
		local nrCompanions = #GupPet_SavedData["Companion"][companionType] ;
		
		for i=1 , nrCompanions do
			--For nr Weight trow it in
			for y=1 , GupPet_SavedData["Companion"][ companionType ][ i ]["Weight"][ locationID ] do
				tinsert( GupPet_MountCache[locationID][companionType] , GupPet_SavedData["Companion"][ companionType ][ i ]["Slot"]  );
			end
		end
	end
	
--	return GupPet_MountCache[locationID][companionType] ;
end

--------------------------------------------------------------------------------------------------------------
--	GupPet_Mount_RemoveCache					 																--
--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------
function GupPet_Mount_RemoveCache( locationID , companionType  )
	
	if companionType and locationID then
		if GupPet_MountCache[locationID] then
			GupPet_MountCache[locationID][companionType] = nil ;
		end
	elseif locationID then
		GupPet_MountCache[locationID] = nil ;
	else
		GupPet_MountCache = {} ;
	end
	
end


----------------------------------------------------------------------------------------------------------------
--	--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

function GupPet_Mount_Aquatic()
	
	if GupPet_Exit() then return true end	-- If you exit something return
	if GupPet_Mount_Pre( "AquaticMount" ) then return true end -- If you can mount return

end

function GupPet_Mount_Ground()
	
	if GupPet_Exit() then return true end	-- If you exit something return
	if GupPet_Mount_Pre( "GroundMount" ) then return true end -- If you can mount return

end

function GupPet_Mount_Fly()
	
	if GupPet_Exit() then return true end	-- If you exit something return
	if GupPet_Mount_Pre( "FlyMount" ) then return true end -- If you can mount return

end

function GupPet_Mount_Multi()
	
	if GupPet_Exit() then return true end	-- If you exit something return
	if GupPet_Mount_Pre( "MultiMount" ) then return true end -- If you can mount return

end


function GupPet_Mount_Auto()

	if GupPet_Exit() then return true end	-- If you exit something return

	
	--If you can fly 
	if GupPet_Mount_CanFly() then
		if GupPet_Mount_Fly() then return true end
	end
	
	--If you can swim
	if GupPet_Mount_CanSwim() then
		if GupPet_Mount_Aquatic() then return true end
		
		-- If you cant pop a aquatic type pop a ground
		if GupPet_Mount_CanGround() then
			if GupPet_Mount_Ground() then return true end
		else
			return false;
		end
	end
	
	--If you can Ground and not forced to use a flyer
	if GupPet_Mount_ForceFly() then
		if GupPet_Mount_Fly() then return true end
	end
	
	if GupPet_Mount_Ground() then return true end
	

end



function GupPet_Mount_Pre( mountType )

	--First get the ID
	local zoneID , globalWorldID , citiesID , instanceID , arenaID , battleGroundID = GupPet_DataHandler_getLocationID()
	local mountFromZoneID = 0 ;
	
	if zoneID > 0 then
		GupPet_Mount_CreateCache( zoneID , mountType );
		
		if #GupPet_MountCache[zoneID][mountType] > 0 then
			mountFromZoneID = zoneID ;
		end
	end
	
	if mountFromZoneID == 0 then
	
		_, instanceType = IsInInstance() ;
		local checkZoneID = 0 ;
	
		if ( IsResting() ) then
			checkZoneID = citiesID ;
		elseif ( instanceType == "pvp" ) then
			checkZoneID = battleGroundID ;
		elseif ( instanceType == "arena" ) then
			checkZoneID = arenaID ;
		elseif ( instanceType == "party" or instanceType == "raid" ) then
			checkZoneID = instanceID ;
		else
			checkZoneID = globalWorldID ;
		end
		
		GupPet_Mount_CreateCache( checkZoneID , mountType );
		if #GupPet_MountCache[checkZoneID][mountType] > 0 then
			mountFromZoneID = checkZoneID ;
		end
	end
	
	
	if mountFromZoneID == 0 then
		GupPet_Mount_CreateCache( globalWorldID , mountType );
		if #GupPet_MountCache[globalWorldID][mountType] > 0 then
			mountFromZoneID = globalWorldID ;
		end
	end
	
	
	-- Go Mount
	if mountFromZoneID > 0 then
		GupPet_Mount_Summon( mountFromZoneID , mountType )
		return true;
	end
	return false;
	
end

function GupPet_Mount_Summon( locationID , mountType )

	local randomSummon = math.random( #GupPet_MountCache[locationID][mountType]  );
	CallCompanion("MOUNT", GupPet_MountCache[locationID][mountType][randomSummon] ) ;
	
	-- FIX that you wont be dismissed while mounting 
	GupPet_Companion_AutoHold();
	
end

--[[


----------------------------------------------------------------------------------------------------------------
	GupPetet_AutoGround						 														
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_AutoGround()
	if GupPetet_Exit() then return end ;	-- If you exit something return
	if IsSwimming() then  if GupPetet_PreMounten( "Aquatic" ) then return end end -- If you can swim then swim ;p
	
	if GupPetet_PreMounten( "Ground" ) then	return true end ;
	
	return false;
end

----------------------------------------------------------------------------------------------------------------
	GupPetet_AutoFly						 															
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupPetet_AutoFly()
	if GupPetet_Exit() then return end ;	-- If you exit something return

	if GupPetet_PreMounten( "Fly" ) then	return true end ;

	return false;
end


]]